/*********
*
* This file is part of BibleTime's source code, http://www.bibletime.info/.
*
* Copyright 1999-2008 by the BibleTime developers.
* The BibleTime source code is licensed under the GNU General Public License version 2.0.
*
**********/

#ifndef BTCONFIG_H
#define BTCONFIG_H

#include <QObject>
#include <QVariant>
#include <QString>
#include <QMap>
#include <QSettings>


class BtConfig : public QObject
{
	Q_OBJECT
public:

	enum ConfigFlag{Save, NoSave, ReadOnly};

	BtConfig();
	~BtConfig();

	void set(QString key, QVariant value);
	QVariant get(QString key);
	QVariant getDefault(QString key);

private:
	struct ConfigStruct
	{
		QVariant defaultValue;
		ConfigFlag flag;
		QVariant::Type type;
	};

	void add(QString key, QVariant defaultValue, ConfigFlag flag, QVariant::Type type);
	void init();
	
	QMap<QString, ConfigStruct> m_defaultMap;
	QMap<QString, QVariant> m_nonSaveSettings;
	QSettings m_settings;
};


#endif
